var commandPalette = (function () {

	var isSublist = false;
	var parentPalettes = [];
	var currentItems = [];

	var paletteItems = [{
			id: '',
			string: 'Document: New',
			shortcut: "Ctrl+N",
			action: "newDocument",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf01c;"
		}, {
			id: '',
			string: 'Document: Save',
			shortcut: "Ctrl+S",
			action: "save",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf01c;"
		}, {
			id: '',
			string: 'Document: Save as File & Bind to Document',
			shortcut: "Ctrl+Shift+S",
			action: "files.saveWmFileAs",
			type: "exe_global",
			sublist: [],
			persist: false,
			icon: "&#xf01c;"
		}, {
			id: '',
			string: 'Document: Print Plain Text (doc or selection)',
			shortcut: "Ctrl+P",
			action: "wm.printText",
			type: "exe_global",
			sublist: [],
			persist: false,
			icon: "&#xf01c;"
		}, {
			id: '',
			string: 'Document: Open File',
			shortcut: "Ctrl+Shift+N",
			action: 'newDocumentFromFile',
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf01c;"
		}, {
			id: '',
			string: 'Document: Backup: Show Restore Points (Saved History)',
			shortcut: "",
			action: "storage.showDocumentHistoryPalette",
			type: "exe_global",
			sublist: [0],
			persist: false,
			icon: "&#xf1da;",
			widget: {
				type: "eval",
				value: '"May take a while to show"'
			}
		},

		{
			id: '',
			string: 'Documents: Open from Palette List',
			shortcut: "Ctrl+Shift+U",
			action: "",
			type: "sublist",
			sublist: "storage.getDocumentsPaletteItems()",
			persist: false,
			icon: "&#xf01c;"
		}, {
			id: '',
			string: 'Documents: Empty Trash',
			shortcut: "",
			action: "storage.emptyTrash",
			type: "exe_global",
			sublist: "",
			persist: false,
			icon: "&#xf01c;"
		},


		{
			id: '',
			string: 'Projects: Create New',
			shortcut: "",
			action: "storage.newProject",
			type: "exe_global",
			sublist: "",
			persist: false,
			icon: "&#xf07c",
			keep_focus: true
		}, {
			id: '',
			string: 'Projects: Open from Palette List',
			shortcut: "Ctrl+Shift+I",
			action: "storage.showProjectsPalette",
			type: "exe_global",
			sublist: "[0]",
			persist: false,
			icon: "&#xf07c"
			// widget: {
			// 	type: "eval",
			// 	value: "\"pisarije\""
			// }
		},

		{
			id: '',
			string: 'Projects: Close Project',
			shortcut: "",
			action: "storage.closeProject",
			type: "exe_global",
			sublist: "",
			persist: false,
			icon: "&#xf07c",
			keep_focus: true
		},

		{
			id: '',
			string: 'Repository: Access from Palette List',
			shortcut: "Ctrl+Shift+R",
			action: "",
			type: "sublist",
			sublist: "repository.getRepoPaletteItems()",
			persist: false,
			icon: "&#xf0b1;"
		}, {
			id: '',
			string: 'Folding: Toggle Fold/Unfold All Headings and Lists',
			shortcut: "Ctrl+9",
			action: "toggleFoldAll",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf066;"
		}, {
			id: '',
			string: 'Folding: Toggle Fold/Unfold Heading or List Item',
			shortcut: "Ctrl+8",
			action: "toggleFold",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf066;"
		}, {
			id: '',
			string: 'Folding: Toggle Collapse Selection / Paragraph',
			shortcut: "F5",
			action: "collapseSelection",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf066;"
		}, {
			id: '',
			string: 'Folding: Expand All Collapsed Ranges',
			shortcut: "",
			action: "expandAllRegions",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf066;"
		}, {
			id: '',
			string: 'Folding: Toggle Segment Focus (selection or sentence)',
			shortcut: "F6",
			action: "toggleFocus",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf066;"
		}, {
			id: '',
			string: 'Jumps: Jump from Palette List',
			shortcut: "Ctrl+Shift+O",
			action: "",
			type: "sublist",
			sublist: "jumps.getJumpsPaletteItems()",
			persist: false,
			icon: "&#xf14e;"
		}, {
			id: '',
			string: 'Jumps: Copy Table of Contents as Text',
			shortcut: "",
			action: "jumps.copyTocAsString",
			type: "exe_global",
			sublist: "",
			persist: false,
			icon: "&#xf14e;"
		}, {
			id: '',
			string: 'Search: New search',
			shortcut: "Ctrl+F",
			action: "find",
			type: "exe_editor",
			sublist: [],
			persist: false,
			keep_focus: true,
			icon: "&#xf002;"
		},

		{
			id: '',
			string: 'Search: New Persistent Search',
			shortcut: "",
			action: "findPersistent",
			type: "exe_editor",
			sublist: [],
			persist: false,
			keep_focus: true,
			icon: "&#xf002;"
		},

		{
			id: '',
			string: 'Search: Find Next',
			shortcut: "F3",
			action: "findNext",
			type: "exe_editor",
			sublist: [],
			persist: true,
			icon: "&#xf002;"
		}, {
			id: '',
			string: 'Search: Find Previous',
			shortcut: "Shift+F3",
			action: "findPrev",
			type: "exe_editor",
			sublist: [],
			persist: true,
			icon: "&#xf002;"
		}, {
			id: '',
			string: 'Search: Clear search',
			shortcut: "",
			action: "clearSearch",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf002;"
		}, {
			id: '',
			string: 'Search: Replace All with Confirm',
			shortcut: "Shift+Ctrl+F",
			action: "replace",
			type: "exe_editor",
			sublist: [],
			persist: false,
			keep_focus: true,
			icon: "&#xf002;"
		}, {
			id: '',
			string: 'Search: Replace All',
			shortcut: "Ctrl+H",
			action: "replaceAll",
			type: "exe_editor",
			sublist: [],
			persist: false,
			keep_focus: true,
			icon: "&#xf002;"
		}, {
			id: '',
			string: 'Search: Show / Hide Search Matches',
			shortcut: "Ctrl+1",
			action: "showSelectionMatches",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf002;"
		}, {
			id: '',
			string: 'Search: Jump to the Position of Last Change',
			shortcut: "F4",
			action: "jumpToLastChangeSpot",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf002;"
		}, {
			id: '',
			string: 'Edit: Toggle Overwrite Mode',
			shortcut: "Ins",
			action: "toggleOverwrite",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Markdown: Toggle Bold',
			shortcut: "Ctrl+B",
			action: "toggleBold",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Markdown: Toggle Italic',
			shortcut: "Ctrl+I",
			action: "toggleItalic",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Markdown: Toggle Inline Code',
			shortcut: "Ctrl+O",
			action: "toggleCode",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Markdown: Toggle Comment ',
			shortcut: "Ctrl+R",
			action: "toggleComment",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Markdown: Toggle Strikethrough',
			shortcut: "Ctrl+T",
			action: "toggleStrikethrough",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Markdown: Headings Level Up',
			shortcut: "Alt+Up",
			action: "headingsUp",
			type: "exe_editor",
			sublist: [],
			persist: true,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Markdown: Headings Level Down',
			shortcut: "Alt+Down",
			action: "headingsDown",
			type: "exe_editor",
			sublist: [],
			persist: true,
			icon: "&#xf044;"
		},  {
			id: '',
			string: 'Edit: Markdown: Convert Selected Tab-separated Lines to Markdown Table',
			shortcut: "",
			action: "convertToMdTable",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		},
		{
			id: '',
			string: 'Edit: Markdown: Toggle Mark',
			shortcut: "Ctrl+E",
			action: "toggleMarked",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Move to Repository',
			shortcut: "Ctrl+Shift+M",
			action: "moveToRepository",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Copy to Repository',
			shortcut: "Ctrl+Shift+L",
			action: "copyToRepository",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Expand Repository Snippet',
			shortcut: "Ctrl+Shift+E",
			action: "expandSnippet",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Undo',
			shortcut: "Ctrl+Z",
			action: "undo",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Redo',
			shortcut: "Ctrl+Y",
			action: "redo",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: To Lower Case',
			shortcut: "Ctrl+K,L",
			action: "downcaseAtCursor",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: To Upper Case',
			shortcut: "Ctrl+K,U",
			action: "upcaseAtCursor",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: To Title Case',
			shortcut: "Ctrl+K,T",
			action: "titlecaseAtCursor",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Hard Wrap Paragraph at Position',
			shortcut: "",
			action: "hardWrapAtPosition",
			type: "exe_editor",
			sublist: [],
			persist: false,
			keep_focus: true,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Remove New Lines from Selection (undo hard wrap)',
			shortcut: "",
			action: "removeNewLinesFromSelection",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'Edit: Clean Text (remove redundant spaces, tabs, newlines)',
			shortcut: "Ctrl+K,C",
			action: "cleanText",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf044;"
		}, {
			id: '',
			string: 'View: Toggle Full Screen',
			shortcut: "Esc",
			action: "win.toggleFullscreen",
			type: "exe_global",
			sublist: [],
			persist: false,
			icon: "&#xf06e;",
			widget: {
				type: "eval",
				value: 'win.isFullscreen ? "ON" : "OFF"'
			}
		}, {
			id: '',
			string: 'View: Toggle White Spaces',
			shortcut: "F8",
			action: "toggleWhiteSpaces",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf06e;",
			widget: {
				type: "eval",
				value: '_editor.getOption("showWhitespaces") ? "ON" : "OFF"'
			}
		}, {
			id: '',
			string: 'View: Focus: Toggle Highlight Active Paragraph',
			shortcut: "",
			action: "toggleStyleActiveLine",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf06e;",
			widget: {
				type: "setting",
				value: "VIEW_STYLE_ACTIVE_LINE"
			}
		}, {
			id: '',
			string: 'View: Focus: Toggle Highlight Current Sentence',
			shortcut: "Ctrl+F7",
			action: "toggleStyleCurrentSentence",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf06e;",
			widget: {
				type: "setting",
				value: "VIEW_STYLE_CURRENT_SENTENCE"
			}
		}, {
			id: '',
			string: 'View: Focus: Toggle Sentence Breakup',
			shortcut: "Ctrl+F8",
			action: "toggleSentenceBreakup",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf06e;",
			widget: {
				type: "setting",
				value: "VIEW_SHOW_SENTENCE_BREAKUP"
			}
		}, {
			id: '',
			string: 'View: Focus: Toggle Anchored Reading',
			shortcut: "Ctrl+F9",
			action: "toggleAnchoredReading",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf13d;",
			widget: {
				type: "setting",
				value: "VIEW_SHOW_ANCHORED_READING"
			}
		}, {
			id: '',
			string: 'View: Focus: Toggle Fade Inactive Paragraphs',
			shortcut: "Ctrl+F6",
			action: "toggleFadeInactiveParagraphs",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf06e;",
			widget: {
				type: "setting",
				value: "VIEW_FADE_INACTIVE_PARAGRAPHS"
			}
		}, {
			id: '',
			string: 'View: Focus: Toggle Fade User Interface',
			shortcut: "",
			action: "wm.toggleAutoHide",
			type: "exe_global",
			sublist: [],
			persist: false,
			icon: "&#xf06e;",
			widget: {
				type: "setting",
				value: "VIEWPORT_AUTO_FADE_ENABLED"
			}
		}, {
			id: '',
			string: 'View: Reset Text Zoom',
			shortcut: "Ctrl+0",
			action: "resetZoom",
			type: "exe_editor",
			icon: "&#xf06e;",
			sublist: [],
			persist: false
		}, {
			id: '',
			string: 'View: Text Zoom In',
			shortcut: "Ctrl+7",
			action: "increaseFontZoom",
			type: "exe_editor",
			icon: "&#xf06e;",
			sublist: [],
			persist: true
		}, {
			id: '',
			string: 'View: Text Zoom Out',
			shortcut: "Ctrl+6",
			action: "decreaseFontZoom",
			type: "exe_editor",
			icon: "&#xf06e;",
			sublist: [],
			persist: true
		}, {
			id: '',
			string: 'View: Wider Text Area',
			shortcut: "Ctrl+5",
			action: "increaseTextAreaWidth",
			type: "exe_editor",
			sublist: [],
			icon: "&#xf06e;",
			persist: true
		}, {
			id: '',
			string: 'View: Narrower Text Area',
			shortcut: "Ctrl+4",
			action: "decreaseTextAreaWidth",
			type: "exe_editor",
			sublist: [],
			icon: "&#xf06e;",
			persist: true
		}, {
			id: '',
			string: 'View: Lock Current Text Zoom as Default',
			shortcut: "",
			action: "setResetZoomDefault",
			type: "exe_editor",
			sublist: [],
			icon: "&#xf06e;",
			persist: false
		}, {
			id: '',
			string: 'View: Set User Interface Zoom Value',
			shortcut: "",
			action: "wm.setUiZoom",
			type: "exe_global",
			sublist: [],
			icon: "&#xf06e;",
			persist: false,
			keep_focus: true,
			widget: {
				type: "eval",
				value: 'localStorage["VIEWPORT_UI_ZOOM"] ? localStorage["VIEWPORT_UI_ZOOM"]  + "%" : "100%"'
			}
		},


		{
			id: '',
			string: 'View: Lock Typewriter Scrolling at Current Cursor Position',
			shortcut: "",
			action: "lockAtCurrentPosition",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf06e;",
			// widget: {
			// 	type: "eval",
			// 	value: 'parseInt(localStorage["VIEWPORT_TYP_SCROLLING_POSITION"], 10).toFixed(1)'
			// }

		}, {
			id: '',
			string: 'View: Toggle Typewriter Scrolling on / off',
			shortcut: "Ctrl+Shift+T",
			action: "toggleTypewriterScrolling",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf06e;",
			widget: {
				type: "setting",
				value: "VIEW_TYPEWRITER_SCROLLING"
			}
		},

		// {
		// 	id: '',
		// 	string: 'View: Toggle Syntax Highlighting for Markdown on / off',
		// 	shortcut: "Ctrl+Shift+H",
		// 	action: "toggleSyntaxHighlighting",
		// 	type: "exe_editor",
		// 	sublist: [],
		// 	persist: false
		// },

		{
			id: '',
			string: 'View: Toggle Lock Window on Top on / off',
			shortcut: "",
			action: "wm.toggleLockOnTop",
			type: "exe_global",
			sublist: [],
			persist: false,
			icon: "&#xf06e;",
			widget: {
				type: "setting",
				value: "VIEWPORT_WINDOW_LOCKED_ON_TOP"
			}
		}, {
			id: '',
			string: 'View: Toggle Universal Pane',
			shortcut: "F12",
			action: "universalPane.togglePanes",
			type: "exe_global",
			sublist: [],
			icon: "&#xf06e;",
			persist: true
		}, {
			id: '',
			string: "View: Set Theme, UI filters, Font & Line Spacing",
			shortcut: "",
			action: "",
			type: "sublist",
			icon: "&#xf1fc;",
			sublist: [{
				id: '',
				string: 'Reset All Filters',
				shortcut: "",
				action: "wm.resetAllFilters",
				type: "exe_global",
				sublist: [],
				persist: true
			},{
				id: '',
				string: 'Edit Current Theme File in Default CSS Editor',
				shortcut: "",
				action: "storage.openDefaultThemeFile",
				type: "exe_global",
				icon: "&#xf013;",
				sublist: [],
				persist: false,
				widget: {
					type: "eval",
					value: '_currentTheme + ".css"'
				}
			}, {
				id: '',
				string: 'Rotate Brightness',
				shortcut: "",
				action: "wm.rotateBrightness",
				icon: "&#xf042;",
				type: "exe_global",
				sublist: [],
				persist: true
			}, {
				id: '',
				string: 'Rotate Sepia',
				shortcut: "",
				action: "wm.rotateSepia",
				icon: "&#xf042;",
				type: "exe_global",
				sublist: [],
				persist: true
			}].concat(wm.getThemes(), wm.getFonts(), wm.getFilterSchemes()).concat({
				id: '',
				string: 'Reset All Filters',
				shortcut: "",
				action: "wm.resetAllFilters",
				type: "exe_global",
				sublist: [],
				persist: true
			}),
			persist: false,
			widget: {
				type: "eval",
				value: 'localStorage["VIEWPORT_THEME"] + ", " + localStorage["VIEWPORT_MAIN_FONT"]'
			}
		}, {
			id: '',
			string: 'Bookmarks: Insert Bookmark',
			shortcut: "Ctrl+F2",
			action: "newWmBookmark",
			type: "exe_editor",
			sublist: [],
			icon: "&#xf02e;",
			persist: false
		}, {
			id: '',
			string: 'Bookmarks: Jump to Next Bookmark',
			shortcut: "F2",
			action: "nextWmBookmark",
			type: "exe_editor",
			sublist: [],
			icon: "&#xf02e;",
			persist: true
		}, {
			id: '',
			string: 'Bookmarks: Jump to Previous Bookmark',
			shortcut: "Shift+F2",
			action: "prevWmBookmark",
			type: "exe_editor",
			sublist: [],
			icon: "&#xf02e;",
			persist: true
		}, {
			id: '',
			string: 'Bookmarks: Clear All Bookmarks',
			shortcut: "Shift+Ctrl+F2",
			action: "clearWmBookmarks",
			type: "exe_editor",
			icon: "&#xf02e;",
			sublist: [],
			persist: false
		}, {
			id: '',
			string: 'Application: Show Development tools',
			shortcut: "",
			action: "win.showDevTools",
			type: "exe_global",
			sublist: [],
			icon: "&#xf013;",
			persist: false
		}, {
			id: '',
			string: 'Application: Database: Compact',
			shortcut: "",
			action: "storage.compactCollection",
			type: "exe_global",
			sublist: [],
			persist: false,
			icon: "&#xf1c0;",
			widget: {
				type: "eval",
				value: '(localStorage.DATABASE_LAST_COMPACT && localStorage.DATABASE_LAST_COMPACT != "") ? "Last: " + moment(parseInt(localStorage.DATABASE_LAST_COMPACT, 10)).fromNow() : "Never compacted"'
			}

		}, {
			id: '',
			string: 'Application: Database: Backup Database',
			shortcut: "",
			action: "storage.backupDatabase",
			type: "exe_global",
			sublist: [],
			persist: false,
			icon: "&#xf1c0;",
			widget: {
				type: "eval",
				value: '(localStorage.DATABASE_LAST_BACKUP && localStorage.DATABASE_LAST_BACKUP != "") ? "Last: " + moment(parseInt(localStorage.DATABASE_LAST_BACKUP, 10)).fromNow() : "No backup"'
			}

		}, {
			id: '',
			string: 'Application: Open Directory with Database files',
			shortcut: "",
			action: "storage.openDBfolder",
			type: "exe_global",
			sublist: [],
			icon: "&#xf1c0;",
			persist: false
		}, {
			id: '',
			string: 'Application: Open Directory with Database Backup files',
			shortcut: "",
			action: "storage.openBackupFolder",
			type: "exe_global",
			sublist: [],
			icon: "&#xf1c0;",
			persist: false
		}, {
			id: '',
			string: 'Application: Open Setting Files in Default JSON Editor',
			shortcut: "",
			action: "storage.openSettingFiles",
			type: "exe_global",
			sublist: [],
			icon: "&#xf013;",
			persist: false,
			widget: {
				type: "eval",
				value: '"settings_main AND settings_main_user"'
			}
		},{
			id: '',
			string: 'Application: Enter Writemonkey License Key',
			shortcut: "",
			action: 'wm.enterWmLicenseKey',
			type: "exe_global",
			sublist: [],
			icon: "&#xf013;",
			persist: false,
			keep_focus: true,
			widget: {
				type: "eval",
				value: '(localStorage.LICENSE_KEY && localStorage.LICENSE_KEY != "") ? "REGISTERED" : "NOT REGISTERED"'
			}

		}, {
			id: '',
			string: 'Application: Remove Writemonkey License Key',
			shortcut: "",
			action: 'wm.removeWmLicenseKey',
			type: "exe_global",
			sublist: [],
			icon: "&#xf013;",
			persist: false
		}, {
			id: '',
			string: 'Application: Quit',
			shortcut: "",
			action: "app.closeAllWindows",
			type: "exe_global",
			sublist: [],
			icon: "&#xf013;",
			persist: false
		}, {
			id: '',
			string: 'Sounds: Start/Stop White Noise Loops',
			shortcut: "",
			action: "",
			type: "sublist",
			sublist: "wm.getWhiteNoiseSounds()",
			persist: false,
			icon: "&#xf025;",
			widget: {
				type: "eval",
				value: 'localStorage["SOUNDS_WHITE_NOISE_SELECTED_SCHEME"] != "" ?  localStorage["SOUNDS_WHITE_NOISE_SELECTED_SCHEME"] : "OFF"'
			}
		}, {
			id: '',
			string: 'Language: Spelling: Toggle Spelling on / off',
			shortcut: "F7",
			action: "toggleSpelling",
			type: "exe_editor",
			sublist: [],
			persist: false,
			icon: "&#xf1d7;",
			widget: {
				type: "eval",
				value: '_editor.getOption("mode") == "spell-checker" ? "ON" : "OFF"'
			}

		}, {
			id: '',
			string: 'Language: Spelling: Select Spelling Dictionary',
			shortcut: "",
			action: "",
			type: "sublist",
			sublist: "_editor.getSpellingDictionaries()",
			icon: "&#xf1d7;",
			persist: false,
			widget: {
				type: "eval",
				value: '(localStorage.LANGUAGE_SPELLING_DICTIONARY && localStorage.LANGUAGE_SPELLING_DICTIONARY != "") ? localStorage.LANGUAGE_SPELLING_DICTIONARY : "not set"'
			}
		}, {
			id: '',
			string: 'Progress: Start New Session',
			shortcut: "",
			action: "wm.startNewSession",
			type: "exe_global",
			sublist: [],
			icon: "&#xf0e4;",
			persist: false
		},

		// {
		// 	id: '',
		// 	string: 'Progress: Pause/Unpause Current Session',
		// 	shortcut: "",
		// 	action: "wm.pauseUnpauseCurrentSession",
		// 	type: "exe_global",
		// 	sublist: [],
		// 	persist: false
		// }

		{
			id: '',
			string: 'Progress: Stop Current Session',
			shortcut: "",
			action: "wm.stopCurrentSession",
			type: "exe_global",
			sublist: [],
			icon: "&#xf0e4;",
			persist: false
		}, {
			id: '',
			string: 'Help: Visit Writemonkey Home Page',
			shortcut: "",
			action: 'opener("http://writemonkey.com")',
			type: "eval",
			sublist: [],
			persist: false,
			icon: "&#xf059;",
			widget: {
				type: "eval",
				value: '"<span class=\\"awf\\">&#xf08e;</span>"'
			}
		}, {
			id: '',
			string: 'Help: Report Bug / Issue',
			shortcut: "",
			action: 'opener("https://github.com/writemonkey/wm3/issues")',
			type: "eval",
			sublist: [],
			persist: false,
			icon: "&#xf059;",
			widget: {
				type: "eval",
				value: '"<span class=\\"awf\\">&#xf08e;</span>"'
			}
		}, {
			id: '',
			string: 'Help: Documentation',
			shortcut: "F1",
			action: 'opener("https://github.com/writemonkey/wm3/wiki/Documentation")',
			type: "eval",
			sublist: [],
			persist: false,
			icon: "&#xf059;",
			widget: {
				type: "eval",
				value: '"<span class=\\"awf\\">&#xf08e;</span>"'
			}
		}, {
			id: '',
			string: 'Help: Keyboard Shortcuts',
			shortcut: "",
			action: 'opener("https://github.com/writemonkey/wm3/wiki/Documentation#keyboard-shortcuts")',
			type: "eval",
			sublist: [],
			persist: false,
			icon: "&#xf059;",
			widget: {
				type: "eval",
				value: '"<span class=\\"awf\\">&#xf08e;</span>"'
			}
		}, {
			id: '',
			string: 'Help: Markdown Cheat Sheet',
			shortcut: "",
			action: 'opener("https://www.markdownguide.org/cheat-sheet/")',
			type: "eval",
			sublist: [],
			persist: false,
			icon: "&#xf059;",
			widget: {
				type: "eval",
				value: '"<span class=\\"awf\\">&#xf08e;</span>"'
			}
		}, {
			id: '',
			string: 'Help: Changelog',
			shortcut: "",
			action: 'opener("https://github.com/writemonkey/wm3/wiki/Changelog")',
			type: "eval",
			sublist: [],
			persist: false,
			icon: "&#xf059;",
			widget: {
				type: "eval",
				value: '"<span class=\\"awf\\">&#xf08e;</span>"'
			}
		}, {
			id: '',
			string: 'Help: Support Writemonkey via PayPal',
			shortcut: "",
			action: 'opener("https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=FBR9FAQ2YHST8")',
			type: "eval",
			sublist: [],
			persist: false,
			icon: "&#xf1ed;",
			widget: {
				type: "eval",
				value: '"<span class=\\"awf\\">&#xf08e;</span>"'
			}
		},
		{
			id: '',
			string: 'Search with Google in Default Browser',
			shortcut: "Ctrl+K,G",
			action: 'searchWithGoogle',
			type: 'exe_editor',
			sublist: [],
			persist: false,
			icon: "&#xf1a0;",
			widget: {
				type: "eval",
				value: '"Prompt is a selection or a current line"'
			}
		}
	];


	/*
	########   ##     ##  ########    ######
	##          ##   ##   ##         ##    ##
	##           ## ##    ##         ##
	######        ###     ######     ##
	##           ## ##    ##         ##
	##          ##   ##   ##         ##    ##
	########   ##     ##  ########    ######
	*/
	function executeCommand(item) {

		if (item.type == "exe_global") {
			var func = new Function(item.action + "()");
			func();
		} else if (item.type == "eval") {
			try {
				eval(item.action);
			} catch (e) {
				console.log(e);
			}
		} else if (item.type == "exe_editor") {
			_editor.execCommand(item.action);
		} else if (item.type == "sublist") {

			// store as parent
			parentPalettes.push(currentItems);

			$("#command-palette-wrapper").remove(); // always close existing

			// check if sublist is array
			if (item.sublist.constructor === Array) { // is literal array
				showCommandPalette(item.sublist);
			} else { // must be function name - fetch items
				var subitems = [];
				try {
					subItems = eval(item.sublist);
				} catch (er) {
					// show error notice
				}
				showCommandPalette(subItems);
			}
			$('.searchFilter').val("");
		}

		// focus editor
		if (item.type != "sublist" && !item.persist && !item.keep_focus) {
			setTimeout(function () {
				_editor.focus();
			}, 20);
		}
	}


	// will be appended to the current list
	function registerPaletteItem(item) { // object or array of objects

		// check if array
		paletteItems.push(item);

	}
	// will remove from the list
	function removePaleteItems(ids) { // single id or array of ids (string)

		// check if array

	}


	function hidePaletteItem(id) {

	}


	function showPaletteItem(id) {

	}





	function showParentPalette() {
		$("#command-palette-wrapper").remove(); // always close existing
		showCommandPalette();

	}


	function hideCommandPalette() {
		$("#command-palette-wrapper").remove();
	}



	function showCommandPalette(items, options) {


		var defaultOptions = {
			isRoot: false
		};

		if (typeof options == 'object') {
			options = $.extend(defaultOptions, options);
		} else {
			options = defaultOptions;
		}

		isSublist = (items && !options.isRoot) ? true : false;
		var itemsToShow = (items) ? items : putRecentPaletteItemsToTop(paletteItems);

		currentItems = itemsToShow;

		// map ctrl to cmd ant alt to opt
		itemsToShow.map(function (item) {
			item.shortcut = (os.platform() === 'darwin') ? item.shortcut.replace(/ctrl/i, "Cmd") : item.shortcut;
			item.shortcut = (os.platform() === 'darwin') ? item.shortcut.replace(/alt/i, "Opt") : item.shortcut;
			return item;
		});
		// ...

		var pl = $('<div/>', {
			id: 'command-palette-wrapper',
			name: 'command-palette-wrapper',
			class: 'command-palette-wrapper'
		}).css({
			"display": "none",
			"position": "relative",
			"background-color": "transparent",
			"width": "39rem",
			"max-height": "19.5rem!important",
			"text-align": "left",
			"margin-left": "calc(50% - 20rem)",
			"top": "0px",
			"position": "fixed",
			"z-index": "1000"
		});

		pl.appendTo('body');


		$('#command-palette-wrapper').commandPalette({
			items: itemsToShow,
			elementsTemplate: '$$ico$$ $$string$$<span class="awf";>$$sub$$ $$persist$$</span> $$widget$$  <span style="float: right; padding-right: 20px; font-size: .9em; opacity: .6; font-weight: bold;">$$shortcut$$</span>',

			onItemSelected: function (item) {
				if (!isSublist) {
					localStorage.setItem('COMMANDPALETTE_LAST_SEARCH', $('#searchFilter').val());
					localStorage.setItem('COMMANDPALETTE_LAST_ITEM', item.string);
					saveRecentlyUsedPaletteItem(item.string);
				}

				executeCommand(item);

				if (!item.persist) {
					pl.remove();
				}
			}

		});

		// not needeed any more
		// $('#searchFilter').attr("placeholder", "");
		// if (!isSublist && !options.isRoot) $('#searchFilter').val(localStorage.getItem('COMMANDPALETTE_LAST_SEARCH'));

		// $('#command-palette-wrapper').slideDown("fast");
		$('#command-palette-wrapper').show();
		$('#searchFilter').keydown().select();

		// if (os.platform() != 'darwin') {
		// 	$('.palette-results').perfectScrollbar({
		// 		suppressScrollX: true
		// 	});
		// }



		$('#wrapper').one("click", function (event) {
			pl.remove();
		});



		$('#searchFilter').on("keydown", function (event) {

			if (event.which == 27 || (event.keyCode == "37")) {
				event.stopPropagation();
				event.preventDefault();

				if (isSublist) {
					pl.remove();
					showParentPalette();
					return;
				}
				pl.remove();
				setTimeout(function () {
					_editor.focus();
				}, 20);



			} else if (event.which == 38 || event.which == 40) {
				event.preventDefault();
				event.stopPropagation();
			}
		});
	};

	function saveRecentlyUsedPaletteItem(item) {

		if (!localStorage['COMMANDPALETTE_RECENT_COMMANDS'])
			localStorage['COMMANDPALETTE_RECENT_COMMANDS'] = "[]";

		var arr = JSON.parse(localStorage['COMMANDPALETTE_RECENT_COMMANDS']);

		if (item !== arr[0]) {

			if (arr.indexOf(item) != -1) {
				arr.splice(arr.indexOf(item), 1);
			}

			arr.unshift(item);

			if (arr.length > _settings.command_palette_num_of_recent_items) {
				arr.splice(-1, 1);
			}
			localStorage['COMMANDPALETTE_RECENT_COMMANDS'] = JSON.stringify(arr);
		}
	}


	function putRecentPaletteItemsToTop(paletteArr) {

		if (!localStorage['COMMANDPALETTE_RECENT_COMMANDS'])
			localStorage['COMMANDPALETTE_RECENT_COMMANDS'] = "[]";

		var recentArr = JSON.parse(localStorage['COMMANDPALETTE_RECENT_COMMANDS']);

		for (var i = 0; i < paletteArr.length; i++) {

			var indexOfRecent = recentArr.indexOf(paletteArr[i].string);
			if (indexOfRecent !== -1) {
				paletteArr[i].recent = "0" + indexOfRecent;
			} else {
				paletteArr[i].recent = "1";
			}
		}



		var sortedArr = _.sortBy(paletteArr, 'recent');

		return sortedArr;
	}



	/*
	   ###     ########   ####
	  ## ##    ##     ##   ##
	 ##   ##   ##     ##   ##
	##     ##  ########    ##
	#########  ##          ##
	##     ##  ##          ##
	##     ##  ##         ####
	*/
	return {
		showCommandPalette: showCommandPalette,
		hideCommandPalette: hideCommandPalette,
		showParentPalette: showParentPalette,
		registerPaletteItem: registerPaletteItem,
		removePaleteItems: removePaleteItems
	};

})();
/* EOF */