var jumps = (function() {

	var headingNumA = [0, 0, 0, 0, 0, 0];
	var currLevel = 0;
	var startAt = 0;

	function __init() {}


	function getJumpsArray() {

		// var t0 = performance.now();

		// reset heading numbers
		headingNumA = [0, 0, 0, 0, 0, 0];
		currLevel = 0;
		startAt = 0;

		var lineCount = _editor.lineCount();
		var items = [];


		var marks = _editor.getAllMarks();

		for (var i = 0; i < marks.length ; i++) {

			if (checkIfEnabled("JUMPS_SHOW_BOOKMARKS") && marks[i].type == "bookmark") {
				var line = _editor.getLine(marks[i].find().line);
				var icon = getIcon("&#xf02e;", "#fc0107", ".8");

				items.push({
					group: "Bookmarks",
					icon: icon,
					text: icon + " " + line,
					raw: line,
					line: marks[i].find().line
				});
			}

			// else if (marks[i].type == "collapsed_region") {
			// 	var line = _editor.getLine(marks[i].find().from.line);
			// 	var icon = getIcon("&#xf066;", "#7F7F7F", "1");

			// 	items.push({
			// 		group: "Collapsed ranges",
			// 		icon: icon,
			// 		text: icon + " " + line,
			// 		raw: line,
			// 		line: marks[i].find().from.line
			// 	});
			// }
		}


		for (var i = 0; i < lineCount; i++) {

			var lineText = _editor.getLine(i);

			// check for markdown header
			var hLevel = _editor.getHeaderLevel({line: i, ch: 0});

			if (checkIfEnabled("JUMPS_SHOW_HEADINGS") && hLevel != -1 && !lineText.startsWith('===') && !lineText.startsWith('---')) {
				var indNumb = addIndent(lineText, hLevel);
				var str = indNumb.string;
				var num = indNumb.number;

				items.push({
					group: "Headings",
					icon: false,
					text: str.replace(/^#{1,6}|#{1,6}$/g, ""),
					raw: lineText,
					line: i,
					number: num
				});

			}

			// images
			else if (checkIfEnabled("JUMPS_SHOW_IMAGES") && lineText.search(/^!\[.*?\]\((.*?)\)/g) != -1) {
				items.push({
					group: "Images",
					icon: '<div style="display: inline; margin-right: 5px; border-radius: 3px; height: 10px; width: 10px; background-image: url(' + getImageSecFromMd(lineText) + '); background-position: top; background-size: cover; background-repeat: no-repeat;"> </div>',
					text: '<div class="thumb" style="border-radius: 3px; height: 100%; max-width: 200px; background-image: url(' + getImageSecFromMd(lineText) + '); background-position: center; background-size: cover; background-repeat: no-repeat;"> </div>',
					raw: lineText,
					line: i //_editor.lineInfo(i).line
				});
			}

			// check for comments
			else if (checkIfEnabled("JUMPS_SHOW_COMMENTS") && lineText.search(/^\/\/.+$/) != -1) {
				var icon = getIcon("&#xf075;", "#3e84d5", ".8");
				items.push({
					group: "Comments",
					icon: icon,
					text: icon + lineText.replace(/\/\/\s*/g, ""),
					raw: lineText,
					line: i //_editor.lineInfo(i).line
				});

			}
			// check for inline comments
			else if (checkIfEnabled("JUMPS_SHOW_COMMENTS") && lineText.search(/^.+(?!:).{1}\/\/.+(\/\/|$)/) != -1) {
				var icon = getIcon("&#xf075;", "#956fcc", ".8");
				items.push({
					group: "Comments",
					icon: icon,
					text: icon + lineText.replace(/\/\//g, ""),
					raw: lineText,
					line: i //_editor.lineInfo(i).line
				});
			}
			// check for done tasks
			else if (checkIfEnabled("JUMPS_SHOW_TASKS") && lineText.search(/^ {0,3}- \[x\] .+/) != -1) {
				var icon = getIcon("&#xf249;", "#e09120;", ".4");
				items.push({
					group: "Tasks",
					icon: icon,
					text: icon + '<tag style="text-decoration: line-through; opacity: .6;">' + lineText.replace(/^ {0,3}- \[x\]/, "") + '</tag>',
					raw: lineText,
					line: i //_editor.lineInfo(i).line
				});
			}
			// check for not done tasks
			else if (checkIfEnabled("JUMPS_SHOW_TASKS") && lineText.search(/^ {0,3}- \[ \] .+/) != -1) {
				var icon = getIcon("&#xf249;", "#e09120", ".8");
				items.push({
					group: "Tasks",
					icon: icon,
					text: icon + lineText.replace(/^ {0,3}- \[ \]/, ""),
					raw: lineText,
					line: i //_editor.lineInfo(i).line
				});
			}

			// footnotes
			if (checkIfEnabled("JUMPS_SHOW_TASK_FOOTNOTES") && lineText.search(/\^\[.+\]|\[\^.+\]:.+/) != -1) {
				var icon = getIcon("&#xf086;", "#5ba14d", ".8");
				items.push({
					group: "Footnotes",
					icon: icon,
					text: icon + lineText.replace(/\[\^.+\]:\s+|\^\[/g, ""),
					raw: lineText,
					line: i //_editor.lineInfo(i).line
				});
			}



			// strikes
			if (checkIfEnabled("JUMPS_SHOW_DELETES") && lineText.search(/.*~~.+~~/) != -1) {
				var icon = getIcon("&#xf057;", "#d53e3e", ".8");
				items.push({
					group: "Deletes",
					icon: icon,
					text: icon + lineText.replace(/~~/g, ""),
					raw: lineText,
					line: i //_editor.lineInfo(i).line
				});
			}

			// marked text
			if (checkIfEnabled("JUMPS_SHOW_MARKED_TEXT") && lineText.search(/.*==\S.+\S==/) != -1 && lineText.search(/^={3,}$/) == -1) {
				var icon = getIcon("&#xf040;", "#ffd700", ".8");
				// console.log(lineTokens);
				items.push({
					group: "Marked text",
					icon: icon,
					text: icon + lineText.replace(/==/g, ""),
					raw: lineText,
					line: i //_editor.lineInfo(i).line
				});
			}

		}

		return items.sort(function(obj1, obj2) { return obj1.line - obj2.line; });
	}


	function checkIfEnabled(setting_name) {
		if (localStorage[setting_name] == "1" || !localStorage[setting_name]) {
			return true;
		}
		return false;
	}


	function getImageSecFromMd(lineText) {
		var m = lineText.match(/^!\[.*?\]\((.*?)\)/);
		return m && m[1] ? m[1].replace(/\\/g, "/") : -1;
	}


	function getIcon(iconCode, color, opa) {
		opa = 1;
		return `<tag style="color: ${color}; opacity: ${opa}; font-size:.9em; font-family:\'Font Awesome\'">${iconCode}</tag> `;
	}


	function addIndent(item, level) {

		if (level >= 1) {
			var dot = _settings.jumps_dotted_indent_for_headings ? "&#183;" : "&nbsp;";
			item = item.replace(/^#+/, "").trim();
			return {
				string: '<tag style="opacity: .3; letter-spacing: .02em; text-decoration: none!important; padding-right: .2em;">' + (dot + dot).repeat(level - 1) + '</tag>' + item,
				number: ""
			};
		} else {
			return {string: "", number: ""};
		}
	}


	var isUpdating = false;
	function updateListBox() {

		if (isUpdating || $('#jumps_list').css("display") != "block") return;
		isUpdating = true;

		$("#jumps_list").jqxListBox('beginUpdate');
		$('#jumps_list').jqxListBox('clearFilter');

		_currentJumpsList = getJumpsArray();

		$("#jumps_list").jqxListBox({
			source: _currentJumpsList,
		});


		$("#jumps_list").jqxListBox('endUpdate');

		isUpdating = false;



		// Higlight current item
		if (_editor.hasFocus()) silentSelect = true;
		$("#jumps_list").jqxListBox('selectItem', activeItem);
		$("#jumps_list").jqxListBox('ensureVisible', activeItem);
	}



	function copyTocAsString() {
		var tocS = '~~~\n';
		var jmps = getJumpsArray();

		for (var i = 0; i < jmps.length; i++) {
			if (jmps[i].group === 'Headings') {
				var num = jmps[i].number;
				var h = jmps[i].raw.replace(/^# /g, '#')
					.replace(/#/g, '\t')
					.replace(/\t+$/g, '')
					.replace(/^\t/g, '');
				tocS += h + '\n'; //' [' + num + ']
			}
		}
		tocS += '~~~\n';

		var clipboard = gui.Clipboard.get();
		clipboard.set(tocS, 'text');
	}




	function createListBox() {

		$("#jumps_list").jqxListBox("clear");

		// _currentJumpsList = getJumpsArray();


		var source = {
			datatype: "array",
			datafields: [{
				name: 'text',
				type: 'string'
			}, {
				name: 'line',
				type: 'string'
			}, {
				name: 'raw',
				type: 'string'
			}],
			id: '_id',
			localdata: _currentJumpsList
		};

		var settings = {
			async: false,
			autoBind: true
		};
		var dataAdapter = new $.jqx.dataAdapter(source, settings);


		$("#jumps_list").jqxListBox({
			theme: "metro",
			selectedIndex: 0,
			// autoItemsHeight: false,
			equalItemsWidth: true,
			enableSelection: true,
			enableHover: true,
			filterable: true,
			filterDelay: 100,
			filterHeight: 35,
			filterPlaceHolder: "<filter>",
			searchMode: "containsignorecase",
			checkboxes: false,
			incrementalSearch: false,
			multiple: false,
			multipleextended: false,
			scrollBarSize: 4,
			itemHeight: -1,
			autoHeight: false, // must be false for scrollbars to work
			allowDrop: false,
			allowDrag: false,
			source: dataAdapter,
			displayMember: "raw",
			valueMember: "line",
			renderer: function(index, label, value) {

				// if (index == -1) return '<div style="height:0px; display: none;"></div>'; //hack for removing groups

				if (index >= 0) label = _currentJumpsList[index].text;

				var height = label.startsWith("<div class=\"thumb\"") ? "4rem" : "1.1rem";

				return '<div class="jumps-tile" style="overflow: hidden; text-overflow: ellipsis; white-space: nowrap; padding: 0px; height: ' + height + '; font-size: .85rem;">' + mdIt.render(label) + '</div>';
			},
			width: "100%",
			height: "100%"
		});

		// _editor.operation(function() {
		// 	_editor.showMatchesOnScrollbar(/^#{1,6}\s+/);
		// });

	}




	var prevSpot;
	function showJumpSpot(line) {

		if (prevSpot) _editor.setGutterMarker(prevSpot, "CodeMirror-universalgutter", null);
		prevSpot = line;

		var htmlNode = document.createElement("span");
		$(htmlNode).css({
			"font-size": ".7em",
			"font-family": "Font Awesome"
		});
		$(htmlNode).html("&#xf054;");

		_editor.setGutterMarker(line, "CodeMirror-universalgutter", htmlNode);
		var showTimer = setTimeout(function() {
			_editor.setGutterMarker(line, "CodeMirror-universalgutter", null);
		}, 3000);
	}



	var silentSelect = false;
	var lineAlreadyChecked = -1;
	var activeItem = null;

	function selectOnNewCursorPosition(cl) {
		if (cl == lineAlreadyChecked) return;

		var lineToShow = -1;

		var arr = _currentJumpsList.filter(function(el) { return el.group == "Headings"});
		// var arr = _currentJumpsList;

		for (var i = 0; i < arr.length; i++) {
			if (cl == arr[i].line) {
				lineToShow = arr[i].line;
				break;
			}
			else if (cl < arr[i].line) {
				lineToShow = arr[i<=0 ? i : i-1].line;
				break;
			}
			else if (i == arr.length - 1 && cl > arr[i].line) {
				lineToShow = arr[i].line;
				break;
			}
		}


		if (lineToShow > -1) {
			silentSelect = true;

			var item = $("#jumps_list").jqxListBox( 'getItemByValue', lineToShow.toString());
			$("#jumps_list").jqxListBox('selectItem', item);
			$("#jumps_list").jqxListBox('ensureVisible', item);
			activeItem = item;
		}
		lineAlreadyChecked = cl;
	}



	function getJumpsPaletteItems() {

		var itemsA = getJumpsArray();
		var paletteA = [];
		// console.log(itemsA);

		for (var i = 0; i < itemsA.length; i++) {

			var ob = itemsA[i];

			paletteA.push({
				id: '',
				string: ob.raw.substring(0, 60) + ' | ' + ob.group,
				shortcut: 'ln: ' + ob.line.toString(),
				action: 'jumps.jumpTo(' + ob.line.toString() + ')',
				type: "eval",
				sublist: [],
				persist: false,
				icon: ob.icon ? ob.icon : ""
			});
		}

		return paletteA;
	}



	function jumpTo(line) {

		_editor.setCursor({line:line, ch:_editor.getLine(line).length}, {
			scroll: false
		});

		_editor.execCommand("scrollCursorToTypewriterPos");
		showJumpSpot(line);
		_editor.execCommand("showScrollBar");

	}



	/*
	########   ##     ##  ########   ##    ##   ########    ######
	##         ##     ##  ##         ###   ##      ##      ##    ##
	##         ##     ##  ##         ####  ##      ##      ##
	######     ##     ##  ######     ## ## ##      ##       ######
	##          ##   ##   ##         ##  ####      ##            ##
	##           ## ##    ##         ##   ###      ##      ##    ##
	########      ###     ########   ##    ##      ##       ######
	*/


	_editor.on("cursorActivity", function(cm) {
		if ($('#jumps_list').css("display") == "block" && _editor.hasFocus()) {
			selectOnNewCursorPosition(cm.getCursor().line);
		}
	});


	$("#jumps_list").on("contextmenu", function(event) {
		event.preventDefault();
		event.stopPropagation();
		// if (!event || !event.args || event.args.item == undefined || event.args.originalEvent == undefined) return;
		// var item = event.args.item;

		var mousex = event.originalEvent.clientX;
		var mousey = event.originalEvent.clientY + 10;

		menus.getJumpTileMenu(0, mousex, mousey).popup(mousex, mousey);
	});



	$("#jumps_list").on('select', function(event) {
		if (silentSelect) {
			silentSelect = false;
			return;
		}

		if (!event || !event.args || event.args.item == undefined || event.args.originalEvent == undefined) return;

		var item = event.args.item;

		jumpTo(item.value);

		// check for modifier key == jump & focus section, fold unfold

		if (event.args.originalEvent.metaKey || event.args.originalEvent.ctrlKey) {
			if (_editor.getFocusedBlock() === false) {
				_editor.setFocus();
			} else {
				_editor.setFocus();
				jumpTo(item.value);
				_editor.setFocus();
			}
		} else {
			if (_editor.getFocusedBlock() !== false) {
				_editor.setFocus();
				jumpTo(item.value);
			}
		}
	});


	$("#jumps_list").on("dblclick", function(e) {
		e.preventDefault();
		e.stopPropagation();
		// e.stopImmediatePropagation();
		_editor.execCommand("toggleFold");
	});


	// Update after number of lines has changed in the editor
	// and is visible
	// When else to update?????
	var lastLineCount = 0;


	_editor.on("change", function(cm, event) {
		if (lastLineCount != _editor.lineCount() && $('#jumps_list').css("display") == "block") {
			setTimeout(function() {
				updateListBox();
				lastLineCount = _editor.lineCount();
			}, 50);
		}
	});


	_editor.on("swapDoc", function(cm, oldDoc) {
		if ($('#jumps_list').css("display") == "block") {
			setTimeout(function() {
				updateListBox();
			}, 10);
		}
	});


	// Update on manual save
	document.body.addEventListener("saveE", function() {
		setTimeout(function() {
			updateListBox();
		}, 50);
	}, false);



	// Call constructor
	__init();


	/*
	   ###     ########   ####
	  ## ##    ##     ##   ##
	 ##   ##   ##     ##   ##
	##     ##  ########    ##
	#########  ##          ##
	##     ##  ##          ##
	##     ##  ##         ####
	*/
	return {
		createListBox: createListBox,
		updateListBox: updateListBox,
		getJumpsPaletteItems: getJumpsPaletteItems,
		jumpTo: jumpTo,
		showJumpSpot: showJumpSpot,
		copyTocAsString: copyTocAsString
	};

})();